
#include <string>
#include <iostream>

int main (void) {

  std::string                         str  = "This is a $(test) of string using the stl.";
  std::string                         str2 = "** REPLACEMENT **";
  std::string::size_type              pos  = 0;
  std::string::size_type              pos2 = 0;
  std::string::iterator               ite;
  std::string::iterator               ite2;
  std::string::traits_type::char_type cha;

  // iterator with pre & post increment

  for (ite = str.begin(); ite != str.end(); ++ite) {
    std::cerr << "#0000 ... " << ite << std::endl;
  }

  for (ite = str.begin(); ite != str.end(); ite++) {
    std::cerr << "#0001 ... " << ite << std::endl;
  }

  // simple dump
  std::cerr << "#0010 ... " << str << std::endl;

  // find
  pos = str.find("$(");
  std::cerr << "#0020 ... " << pos << std::endl;

  pos2 = str.find(")", pos);
  std::cerr << "#0021 ... " << pos2 << std::endl;
  std::cerr << "#0022 ... " << str.substr(pos, pos2-pos+1) << std::endl;

  // at
  std::cerr << "#0030 ... " << str[pos] << std::endl;
  std::cerr << "#0031 ... " << str[pos2] << std::endl;

  cha = str[pos];
  std::cerr << "#0040 ... " << cha << std::endl;

  // iterator
  ite = &str[pos];
  std::cerr << "#0050 ... " << ite << std::endl;

  ite2 = &str[pos2];
  std::cerr << "#0051 ... " << ite2 << std::endl;

  // replace
  ite2++;
  str.replace (ite, ite2, str2);
  std::cerr << "#0060 ... " << str << std::endl;

  return 0;
}